#include "colors.inc"
#include "stones.inc"
#include "gate.inc"


#declare block1 = superellipsoid { <0.2, 0.1>
    scale <2, 1, 1>
    texture { T_Stone12 
        finish {phong .1
                ambient .5
        }
    }
}

#declare block2 = object { block1 rotate x*180 }
#declare block3 = object { block1 rotate y*180 }
#declare block4 = object { block1 rotate z*180 }

#declare shortBlockl = box { <-1,-1,-1> <.8,1,1>
    texture { T_Stone12 
        finish {phong .1
                ambient .5}}
}
#declare shortBlockr = box { <-.8,-1,-1> <1,1,1>
    texture { T_Stone12 
        finish {phong .1
                ambient .5}}
}
#declare battlement = object { block1 }

#declare row = union {
    object { block1 }
    object { block2 translate x*4 }
    object { block3 translate x*8 }
    object { block4 translate x*12 }
    object { block1 translate x*16 }
    object { block2 translate x*20 }
    object { block3 translate x*24 }
    object { block4 translate x*28 }
    object { block1 translate x*32 }
    object { block2 translate x*36 }
    object { block3 translate x*40 }
    object { block4 translate x*44 }
    object { block1 translate x*48 }
    object { block2 translate x*-4 }
    object { block3 translate x*-8 }
    object { block4 translate x*-12 }
    object { block1 translate x*-16 }
}
#declare shortRow = union {
    object { block1 }
    object { block2 translate x*4 }
    object { block3 translate x*8 }
    object { block4 translate x*12 }
    object { block1 translate x*-4 }
    object { block2 translate x*-8 }
    object { block3 translate x*-12 }
    object { block4 translate x*-16 }
}
#declare longRow = union {
    object { block1 }
    object { block2 translate x*4 }
    object { block3 translate x*8 }
    object { block4 translate x*12 }
    object { block1 translate x*16 }
    object { block2 translate x*20 }
    object { block3 translate x*24 }
    object { block4 translate x*28 }
    object { block1 translate x*32 }
    object { block2 translate x*36 }
    object { block3 translate x*40 }
    object { block4 translate x*44 }
    object { block1 translate x*48 }
    object { block2 translate x*52 }
    object { block3 translate x*56 }
    object { block4 translate x*60 }
    object { block1 translate x*-4 }
    object { block2 translate x*-8 }
    object { block3 translate x*-12 }
    object { block4 translate x*-16 }
}
#declare shortBattlement = union{
    object { battlement translate x*2 }
    object { battlement translate x*10 }
    object { battlement translate x*18 }
    object { battlement translate x*26 }
    object { battlement translate x*34 }
    object { battlement translate x*42 }
    object { battlement translate x*-6 }
}
#declare longBattlement = union{
    object { battlement translate x*2 }
    object { battlement translate x*10 }
    object { battlement translate x*18 }
    object { battlement translate x*26 }
    object { battlement translate x*34 }
    object { battlement translate x*42 }
    object { battlement translate x*50 }
    object { battlement translate x*-6 }
}

#declare wall = union {
    object { row }
    object { row translate <2,2,0> }
    object { row translate y*4 }
    object { row translate <2,6,0> }
    object { row translate y*8 }
    object { row translate <2,10,0> }
    object { row translate y*12 }
    object { row translate <2,14,0> }
    object { row translate y*16 }
    object { row translate <2,18,0> }
    object { shortBattlement translate y*20 }
}
#declare longWall = union {
    object { longRow }
    object { longRow translate <-2,2,0> }
    object { longRow translate y*4 }
    object { longRow translate <-2,6,0> }
    object { longRow translate y*8 }
    object { longRow translate <-2,10,0> }
    object { longRow translate y*12 }
    object { longRow translate <-2,14,0> }
    object { longRow translate y*16 }
    object { longRow translate <-2,18,0> }
    object { longBattlement translate y*20 }
}
#declare gateWall = union {
    object { shortRow }
    object { shortRow translate <48,0,0> } 
    object { shortRow translate <2,2,0> }
    object { block1 translate <30,2,0> }
    object { shortRow translate <50,2,0> }
    object { shortRow translate y*4 }
    object { shortRow translate <48,4,0> }
    object { shortRow translate <2,6,0> }
    object { block2 translate <30,6,0> }
    object { shortRow translate <50,6,0> }
    object { shortRow translate y*8 }
    object { shortBlockl translate <15,8,0> }
    object { shortBlockr translate <29,8,0> }
    object { shortRow translate <48,8,0> }
    object { shortRow translate <2,10,0> }
    object { shortBlockl translate <17,10,0> }
    object { shortBlockr translate <27,10,0> }
    object { block3 translate <30,10,0> }
    object { shortRow translate <50,10,0> }
    object { longRow translate y*12 }
    object { longRow translate <2,14,0> }
    object { longRow translate y*16 }
    object { longRow translate <2,18,0> }
    object { gate 
        scale 2 
        translate <22,5,1>
    }
    object { longBattlement translate y*20 }
}

#declare castle1 = union {
    object { gateWall }      //front wall
    object { wall 
        rotate <0,90,0> 
        translate <-17,0,51> //left wall
    }
    object { wall 
        rotate <0,-90,0> 
        translate <63,0,17> //right wall 
    }
    object { longWall 
        translate <2,0,68> //back wall 
    }
    object { aTower    //front left
        rotate y * 180
        translate <-8.5,0,0>
        scale 2
    }
    object { aTower    //front right
        rotate y * 90
        translate <31.5,0,0>
        scale 2
    }
    object { aTower    //back left
        rotate y * 270
        translate <-8.5,0, 34>
        scale 2
    }
    object { aTower    //back right
        translate <31.5,0, 34>
        scale 2
    }
}